/* $Id: array.h,v 1.4 2002/11/18 09:24:14 aa5779 Exp $ */
/*
 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef ARRAY_H
#define ARRAY_H

#include "dstring.h"
#include "interp.h"

#ifndef ARRAY_IMP
extern storage_class array_storage_class;
#endif

storage *array_create(interpreter *i, char *name, char *arg);

void array_destroy(interpreter *i, storage *s);

int array_check(interpreter *i, storage *s, dstring *key);
dstring *array_get(interpreter *i, storage *s, dstring *key);

void array_put(interpreter *i, storage *s, dstring *key, dstring *val);
void array_add(interpreter *i, storage *s, dstring *key, dstring *val);

void array_remove(interpreter *i, storage *s, dstring *key);

dstring *array_first(interpreter *i, storage *s, void **iter);
dstring *array_next(interpreter *i, storage *s, void **iter);
void array_enditer(interpreter *i, storage *s, void **iter);

int array_numofitems(interpreter *i, storage *s);

dstring *array_seek(interpreter *i, storage *s, void **iter, dstring *key);

storage *array_clone(storage *src);

#endif
